float4x4	WorldViewProjMatrix	: WORLDVIEWPROJECTION;

#ifdef MIKUMIKUMOVING
float4 Basic_VS(MMM_SKINNING_INPUT IN) : POSITION
{
	MMM_SKINNING_OUTPUT SkinOut = MMM_SkinnedPositionNormal(IN.Pos, IN.Normal, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);
	float4 Pos = SkinOut.Position;
#else
float4 Basic_VS(float4 Pos : POSITION) : POSITION
{
#endif

	return mul(Pos, WorldViewProjMatrix);
}

float4 Basic_PS(float4 Pos : POSITION) : COLOR0
{
	return float4(0, 0, 0, 0);
}

technique EdgeTec < string MMDPass = "edge"; > { }
technique ZPlotTec < string MMDPass = "zplot"; > { }
technique ShadowTec < string MMDPass = "shadow"; > { }

#define DRAW_OBJECT_PASS \
	pass DrawObject \
	{ \
		AlphaTestEnable = false; \
		AlphaBlendEnable = false; \
		VertexShader = compile vs_3_0 Basic_VS(); \
		PixelShader  = compile ps_3_0 Basic_PS(); \
	}

technique MainTec0 < string MMDPass = "object"; >
{
	DRAW_OBJECT_PASS
}

technique MainTec1 < string MMDPass = "object_ss"; >
{
	DRAW_OBJECT_PASS
}
