////////////////////////////////////////////////////////////////////////////////
//
//  FixedHairLighting.fx
//  쐬: ~[tH
//
////////////////////////////////////////////////////////////////////////////////

// |XgGtFNg錾
float Script : STANDARDSGLOBAL
<
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
float2 ViewportSize : VIEWPORTPIXELSIZE;
static const float2 ViewportOffset = float2(0.5, 0.5) / ViewportSize;

////////////////////////////////////////////////////////////////
// ƗpeNX`
texture FHL_BlendRT : OFFSCREENRENDERTARGET
<
	string Description = "Blend Render Target for FixedHairLighting.fx";
	float4 ClearColor = { 0.5, 0.5, 0.5, 0 };
	float ClearDepth = 1.0;
	bool AntiAlias = true;
	int Miplevels = 1;
	string DefaultEffect =
	    "self = hide;"
	    "Ring.x = none;"
	    "* = hide;";
>;
sampler BlendSampler = sampler_state
{
	texture = <FHL_BlendRT>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
texture FHL_MaskRT : OFFSCREENRENDERTARGET
<
	string Description = "Mask Render Target for FixedHairLighting.fx";
	float4 ClearColor = { 0, 0, 0, 0 };
	float ClearDepth = 1.0;
	bool AntiAlias = true;
	int Miplevels = 1;
	string DefaultEffect =
	    "self = hide;"
	    "Ring.x = hide;"
	    "* = BlackMask.fx;";
>;
sampler MaskSampler = sampler_state
{
	texture = <FHL_MaskRT>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

/////////////////////////////
// Rs[p̃VF[_
struct VS_OUTPUT
{
   float4 Pos: POSITION;
   float2 Tex: TEXCOORD0;
};

VS_OUTPUT CopyVS(float4 Pos : POSITION, float4 Tex : TEXCOORD0)
{ 
	VS_OUTPUT Out;
	
	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	
	return Out;
}

/////////////////////////////
// p̃VF[_
float4 MixPS(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(BlendSampler, Tex);

	Color.rgb = (Color.rgb + (Color.a / 2 - 0.5)) / Color.a;

	return Color * float4(1, 1, 1, tex2D(MaskSampler, Tex).a);
}

////////////////////////////////////////////////////////////////
// GtFNgeNjbN
//
float4 ClearColor = { 0, 0, 0, 0 };
float ClearDepth = 1;

technique PostEffectTec
<
	string Script =
		"ScriptExternal=Color;"
		"Pass=PassMix;";
>
{
	pass PassMix < string Script = "Draw=Buffer;"; >
	{
		AlphaBlendEnable = true;

		VertexShader = compile vs_2_0 CopyVS();
		PixelShader  = compile ps_2_0 MixPS();
	}
};
