#define TEXTURE_FILE "HairLighting.png"
#define TEXTURE_X 512
#define TEXTURE_Y 512

// 摜t̈ʒuA{[[JW
#define OFFSET float3(0, 1.25, 0)

// TCY ({)
#define SCALING 1

// ̊pxɂȂɒǏ]邩 (̏ꍇ 0)
#define TRACE_HEAD 1

#define DEFINE_TEXTURE_SAMPLER(textureName, samplerName, resourceName, uMode, vMode) \
	texture2D textureName < string ResourceName = resourceName; >; \
	sampler samplerName = sampler_state \
	{ \
		Texture = <textureName>; \
		Filter = Anisotropic; \
		AddressU = uMode; \
		AddressV = vMode; \
		MaxAnisotropy = 16; \
	};

DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, TEXTURE_FILE, Clamp, Clamp)

float4x4	WorldViewProjMatrix	: WORLDVIEWPROJECTION;
float4x4	WorldMatrix			: WORLD;
float4x4	ViewMatrix			: VIEW;
float4x4	ProjMatrix			: PROJECTION;
float3		CameraPosition		: POSITION		< string Object = "Camera"; >;

float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = float2(0.5, 0.5) / ViewportSize;

float4x4 BonePosition : CONTROLOBJECT < string name = "(self)"; string item = ""; >;
float3 OffsetPosition : CONTROLOBJECT < string name = "(OffscreenOwner)"; >;
float ScalingValue : CONTROLOBJECT < string name = "(OffscreenOwner)"; >;

struct VS_OUTPUT
{
	float4 Pos				: POSITION;
	float4 ScreenTex		: TEXCOORD8;
};

#ifdef MIKUMIKUMOVING
VS_OUTPUT Basic_VS(MMM_SKINNING_INPUT IN)
{
	MMM_SKINNING_OUTPUT SkinOut = MMM_SkinnedPositionNormal(IN.Pos, IN.Normal, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);
	float4 Pos = SkinOut.Position;
#else
VS_OUTPUT Basic_VS(float4 Pos : POSITION)
{
#endif
	VS_OUTPUT Out = (VS_OUTPUT)0;

#ifdef MIKUMIKUMOVING
	float dist = length((CameraPosition - mul(Pos, WorldMatrix)).xyz);
	Out.Pos = mul(Pos, MMM_IsDinamicProjection ? mul(mul(WorldMatrix, ViewMatrix), MMM_DynamicFov(ProjMatrix, dist)) : WorldViewProjMatrix);
#else
	Out.Pos = mul(Pos, WorldViewProjMatrix);
#endif

	Out.ScreenTex = Out.Pos;

	return Out;
}

float3x2 matrixRotate2D(float rad)
{
	float c = cos(rad);
	float s = sin(rad);
	float3x2 rt = 0;
	
	rt._11 = c;
	rt._12 = s;
	rt._21 = -s;
	rt._22 = c;
	
	return rt;
}

float4 Basic_PS(VS_OUTPUT IN) : COLOR0
{
	float4 LocalBasePos = mul(float4(OFFSET + OffsetPosition, 1), BonePosition);
	float4 BasePos = mul(LocalBasePos, WorldViewProjMatrix);
	float dist = distance(mul(LocalBasePos, WorldMatrix), CameraPosition) / 10;
	float scaling = SCALING * ScalingValue / 10 / dist;
	float2 aspect = float2(ViewportSize.x / ViewportSize.y, 1);
	float2 zoScreenTex = (IN.ScreenTex.xy / IN.ScreenTex.w * 0.5 + 0.5) * aspect;
	float2 zoBasePos = (BasePos.xy / BasePos.w * 0.5 + 0.5) * aspect;
	float2 sc = zoScreenTex / scaling + (1 - zoBasePos / scaling) - 0.5;
	
#if TRACE_HEAD
	float4 TargetPos = mul(mul(float4(0, 10, 0, 1), BonePosition), WorldViewProjMatrix);
	float rad = -atan2(TargetPos.y / TargetPos.w - BasePos.y / BasePos.w, TargetPos.x / TargetPos.w - BasePos.x / BasePos.w) + 3.1415926535 / 2;
	
	sc -= 0.5;
	sc = mul(sc, matrixRotate2D(rad));
	sc += 0.5;
#endif

	sc = float2(sc.x, 1 - sc.y);
	
	return tex2D(BlendDiffuse0TextureSampler, sc);
}

technique EdgeTec < string MMDPass = "edge"; > { }
technique ZPlotTec < string MMDPass = "zplot"; > { }
technique ShadowTec < string MMDPass = "shadow"; > { }

#define DRAW_OBJECT_PASS \
	pass DrawObject \
	{ \
		AlphaTestEnable = true; \
		VertexShader = compile vs_3_0 Basic_VS(); \
		PixelShader  = compile ps_3_0 Basic_PS(); \
	}

technique MainTec0 < string MMDPass = "object"; >
{
	DRAW_OBJECT_PASS
}

technique MainTec1 < string MMDPass = "object_ss"; >
{
	DRAW_OBJECT_PASS
}
